using System;
using System.Collections.Generic;
using System.Text;

namespace SnakeGame
{
    class SnakeGame
    {
        struct SnakeBodySegment
        {
            public int X;
            public int Y;

            public void Erase()
            {
                Console.SetCursorPosition(X, Y);
                Console.Write(' ');
            }

            public void Draw()
            {
                Console.SetCursorPosition(X, Y);
                Console.Write('*');
            }

            public void Update()
            {
            }
        }

        public class Snake
        {

            SnakeGame game;

            SnakeBodySegment[] snake = new SnakeBodySegment[25 * 80];
            int snakeLength = 1;

            int xSpeed = 1;
            int ySpeed = 0;

            int growCount = 0;
            int growLimit = 5;

            public void Erase()
            {
                for (int i = 0; i < snakeLength; i = i + 1)
                {
                    snake[i].Erase();
                }
            }

            public void Draw()
            {
                for (int i = 0; i < snakeLength; i = i + 1)
                {
                    snake[i].Draw();
                }
            }

            public void Update()
            {
                if (Console.KeyAvailable)
                {
                    ConsoleKeyInfo keyInfo = Console.ReadKey(true);

                    switch (keyInfo.Key)
                    {
                        case ConsoleKey.UpArrow:
                            ySpeed = -1;
                            xSpeed = 0;
                            break;
                        case ConsoleKey.DownArrow:
                            ySpeed = 1;
                            xSpeed = 0;
                            break;
                        case ConsoleKey.LeftArrow:
                            ySpeed = 0;
                            xSpeed = -1;
                            break;
                        case ConsoleKey.RightArrow:
                            ySpeed = 0;
                            xSpeed = 1;
                            break;
                    }
                }
                growCount = growCount + 1;

                if (growCount >= growLimit)
                {
                    growCount = 0;
                    snakeLength = snakeLength + 1;
                }

                for (int i = snakeLength; i > 0; i = i - 1)
                {
                    snake[i] = snake[i - 1];
                }

                snake[0].X = snake[0].X + xSpeed;
                snake[0].Y = snake[0].Y + ySpeed;

                /// check for snake colliding with itself

                for (int i = 1; i < snakeLength; i = i + 1)
                {
                    if (snake[0].X == snake[i].X && snake[0].Y == snake[i].Y)
                    {
                        game.gameRunning = false;
                        break;
                    }
                }

                /// check for going off the screen
                /// 
                if (snake[0].X < 0 || snake[0].X >= Console.WindowWidth ||
                    snake[0].Y < 0 || snake[0].Y >= Console.WindowHeight)
                {
                    game.gameRunning = false;
                }
            }

            public Snake(SnakeGame inGame)
            {
                game = inGame;

                for (int i = 0; i < snake.Length; i++)
                {
                    snake[i] = new SnakeBodySegment();
                }
            }
        }

        public bool gameRunning;

        public Snake activeSnake;

        public void PlayGame()
        {

            Console.Clear();

            gameRunning = true;

            activeSnake = new Snake(this);

            while (gameRunning)
            {
                activeSnake.Erase();
                activeSnake.Update();
                activeSnake.Draw();
                System.Threading.Thread.Sleep(100);
            }

            Console.Clear();
            Console.WriteLine("Game Over");

        }

        static void Main(string[] args)
        {
            SnakeGame snake = new SnakeGame();
            snake.PlayGame();
        }
    }
}
